{ HeroesIII }
{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
{$M 16384,0,655360}

type TLine = record
       segN: word;
       r1, L, R, isl: array [1..1500] of integer;
       islN: integer;
       sq: array [1..1500] of longint;
       dead: array [1..1500] of boolean;
     end;

var n, m: integer;
    buf: pointer;
    max, min: longint;
    t: array [1..1000] of byte;
    lp, lc: TLine;
    count: integer;
    used, alive: array [1..1000] of boolean;
    ren, newi: array [1..1000] of integer;

procedure Table2segs;
var p: integer;
begin
  p := 1;

  with lc do begin
    segN := 0;
    repeat
      while (p <= n) and (t[p] = 0) do Inc(p);
      if p > n then break;

      Inc(segN);
      l[segN] := p;

      while (p <= n) and (t[p] = 1) do Inc(p);
      r[segN] := p-1;
    until false;
  end;
end;

procedure Solve;
var i, j, k, q, q0: integer;
    sum: longint;
    x1, x2: integer;
    ToUp: boolean;
    seq: integer;

  procedure CheckForSequel;
  var e: integer;
  begin
    if seq = 0 then begin
      if newi[q] <> 0 then
        seq := newi[q]
    end else begin
      if newi[q] <> 0 then begin
        lc.dead[newi[q]] := True;
        lc.r1[newi[q]] := seq;
      end;
      newi[q] := seq;
    end;
  end;

begin
  Assign(input, 'input.txt'); Reset(input);
  GetMem(buf, 65520);
  SetTextBuf(input, buf^, 65520);

  Read(N, M);
  max := -maxlongint;
  min := maxlongint;

  Fillchar(t, Sizeof(t), 0);
  Fillchar(lc, Sizeof(lc), 0);

  for k := 1 to M do begin

    lp := lc;

    for i := 1 to N do
      Read(t[i]);

    Table2segs;

    count := 0;
    for i := 1 to N do begin
      ren[i] := i;
      lc.r1[i] := i;
    end;
    Fillchar(newi, 2*N, 0);
    Fillchar(lc.sq, 4*N, 0);
    Fillchar(lc.dead, N, 0);

    with lc do begin
      j := 1;

      for i := 1 to segN do begin
        x1 := l[i];
        x2 := r[i];
        Fillchar(used, N, 0);

        while (j <= lp.segN) and (lp.r[j] < x1) do Inc(j);

        ToUp := false;

        while (j <= lp.segN) and (lp.l[j] <= x2) do begin
          used[ren[lp.isl[j]]] := True;
          ToUp := True;
          Inc(j);
        end;

        if ToUp then begin
          if (lp.r[j-1] > x2) then dec(j);

          q := 1;
          while not used[q] do Inc(q);
          sum := lp.sq[q];
          q0 := q;
          seq := 0;
          CheckForSequel;

          inc(q);

          for q := q to lp.islN do
          if used[q] then begin
            ren[q] := q0;
            Inc(sum, lp.sq[q]);
            CheckForSequel;
          end;

          if seq = 0 then begin
            Inc(count);
            seq := count;
            for q := q0 to lp.islN do
              if used[q] then
                newi[q] := seq;
          end;

          lp.sq[q0] := sum;
          isl[i] := seq;
        end else begin
          Inc(count);
          isl[i] := count;
        end;

      end;
      for i := 1 to segN do
        Inc(sq[r1[isl[i]]], r[i]-l[i] + 1);

      for i := 1 to lp.islN do
      if (not lp.dead[i]) and (i = ren[i]) then
      begin
        if newi[i] = 0 then begin
          if lp.sq[i] < min then min := lp.sq[i];
          if lp.sq[i] > max then max := lp.sq[i];
        end else
          Inc(sq[newi[i]], lp.sq[i]);
      end;

      islN := count;
    end;
  end;

  with lc do
  for i := 1 to islN do begin
    if sq[i] < min then min := sq[i];
    if sq[i] > max then max := sq[i];
  end;
  Close(input);
  FreeMem(buf, 65520);
end;

procedure WriteOut;
begin
  assign(output, 'output.txt'); rewrite(output);
  if min = maxlongint then
    Writeln(0)
  else
    Writeln(max/min:0:5);
end;

begin
  Solve;
  WriteOut;
end.